from typing import (Literal,)

class PasswordUtils:
  @classmethod
  def encrypt(
    cls,
    key: str,
    mode: Literal['bytes', 'base64'],
  ) -> tuple[str, str]:
    import os

    from cryptography.hazmat.primitives.kdf.scrypt import Scrypt

    salt = os.urandom(16)

    # derive
    kdf = Scrypt(
      salt=salt,
      length=32,
      n=2**14,
      r=8,
      p=1,
    )

    key = kdf.derive(key.encode('utf-8'))

    if mode == 'bytes':
      return (salt, key)
    elif mode == 'base64':
      return ':'.join([
        base64.b64encode(o, width=0).decode('utf-8')
        for o in [salt, key,]
      ])

    # # verify
    # kdf = Scrypt(
    #   salt=salt,
    #   length=32,
    #   n=2**14,
    #   r=8,
    #   p=1,
    # )
    #
    # kdf.verify(b"my great password", key)
    #
